<?php

class manufactoryCategoryProductsModel extends manufactoryNestedSetModel
{

    protected $table = 'manufactory_category_products';

    protected $left = 'left_key';
    protected $right = 'right_key';
    protected $parent = 'parent_id';

    const TYPE_STATIC = 0;
    const TYPE_DYNAMIC = 1;

    public function getSubcategories($id)
    {
        $categories = $this->descendants($id);
        foreach ($categories as $v) {
            if ($v['parent_id'] != $id) {
                unset($categories[$v['id']]);
            }
        }

        return $categories;
    }

    public function getRights($id)
    {
        return wa()->getUser()->getRights('manufactory', 'product_category.' . $id);
    }

    public function getProducts($id = 0, $start = 0, $limit = 50)
    {
        $start = intval($start);
        $limit = intval($limit);
        if ($limit < 1 || $limit > 500) {
            $limit = 50;
        }
        if ($start > 0) {
            $limit_sql = "LIMIT {$start}, {$limit}";
        } else {
            $limit_sql = "LIMIT {$limit}";
        }
        // Проверяем доступ
        if ($id == 0) {
            return array();
        }

        if ($id > 0) {
            $path = $this->getPath($id, 0);
            if (!empty($path)) {
                $root_category = array_shift($this->getPath($id, 0));
                $root_id = $root_category['id'];
            } else {
                $root_id = $id;
            }
            $category_rights = wa()->getUser()->getRights('manufactory', 'product_category.' . $root_id);
            // Если нет доступа ничего не даем
            if ($category_rights < 1) {
                return array();
            }
        }

        $subcategories = array_keys($this->descendants($id)->fetchAll('id'));
        // TODO: ТУТ бага с доступом
        /*if($id == 0) {
            foreach ($subcategories as $k => $v) {
                if($v['parent_id']== 0 &&  wa()->getUser()->getRights('manufactory','product_category.'.$v['id']) < 1 ) {
                    unset($subcategories[$k]);
                }
            }
        }*/


        $subcategories[] = $id;
        $product_model = new manufactoryProductModel();
        $sql = "SELECT * FROM {$product_model->getTableName()} WHERE " . $product_model->getWhereByField('category_id', $subcategories) . "  ORDER BY name {$limit_sql}";

        return $product_model->query($sql, array())->fetchAll('id');
    }
    /*public function query($sql,$params)
    {

        return parent::query($sql,$params); // TODO: Change the autogenerated stub
    }*/
}
